package com.ruoyi.platform.mapper;

import com.ruoyi.platform.domain.ExperimentIns;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * (ExperimentIns)表数据库访问层
 *
 * @author makejava
 * @since 2023-11-09 09:48:36
 */
public interface ExperimentInsDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ExperimentIns queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param experimentIns 查询条件
     * @param pageable      分页对象
     * @return 对象列表
     */
    List<ExperimentIns> queryAllByLimit(@Param("experimentIns") ExperimentIns experimentIns, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param experimentIns 查询条件
     * @return 总行数
     */
    long count(@Param("experimentIns") ExperimentIns experimentIns);

    long countTorE(@Param("experimentId") Integer experimentId, @Param("isTrain") Boolean isTrain);

    List<ExperimentIns> queryTorE(@Param("experimentId") Integer experimentId, @Param("isTrain") Boolean isTrain, @Param("pageable") Pageable pageable);

    /*
      统计实验实例总数


      @return 总行数
     */
//    long experimentInsCount(String status);

    /**
     * 新增数据
     *
     * @param experimentIns 实例对象
     * @return 影响行数
     */
    int insert(@Param("experimentIns") ExperimentIns experimentIns);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<ExperimentIns> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<ExperimentIns> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<ExperimentIns> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(List<ExperimentIns> entities);

    /**
     * 修改数据
     *
     * @param experimentIns 实例对象
     * @return 影响行数
     */
    int update(@Param("experimentIns") ExperimentIns experimentIns);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);


    /**
     * 根据实验ID查找所有具有相同ID的实例，并将它们添加到实验列表中
     *
     * @param experimentId 实验ID
     * @return 实例列表
     */
    List<ExperimentIns> getByExperimentId(Integer experimentId);

    List<ExperimentIns> getLatestInsList();


    List<ExperimentIns> queryByExperiment(@Param("experimentIns") ExperimentIns experimentIns);

    List<ExperimentIns> queryByExperimentId(Integer id);

    List<ExperimentIns> queryByExperimentIsNotTerminated();
}

